// Copyright 2001  EPITA Research and Development Laboratory
//
// This file is part of the Olena Library.  This library is free
// software; you can redistribute it and/or modify it under the terms
// of the GNU General Public License version 2 as published by the
// Free Software Foundation.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this library; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.
//
// As a special exception, you may use this file as part of a free
// software library without restriction.  Specifically, if other files
// instantiate templates or use macros or inline functions from this
// file, or you compile this file and link it with other files to
// produce an executable, this file does not by itself cause the
// resulting executable to be covered by the GNU General Public
// License.  This exception does not however invalidate any other
// reasons why the executable file might be covered by the GNU General
// Public License.

#ifndef OLENA_CORE_IMAGE_HH
# define OLENA_CORE_IMAGE_HH

# include "core/type.hh"


namespace oln {


  // image

  template<class Inferior = type::bottom>
  struct image : public type::any< image<Inferior> >
  {
    typedef Inferior inferior;
    static std::string name() { return std::string("image<") + Inferior::name() + ">"; }
  protected:
    image() {}
  };


  // mute

  template<class I, class T = typename type::exact<I>::ret::value>
  struct mute
  {
    typedef typename type::exact<I>::ret::mute<T>::ret ret;
  };


# define Value(ImgType)				\
typename type::exact<ImgType>::ret::value

# define Concrete(ImgType)			\
typename mute<ImgType>::ret

# define Iter(Iterable)				\
typename Iterable::iter

# define Point(Pointable)			\
typename Pointable::point

# define DPoint(DPointable)			\
typename DPointable::dpoint

} // end of oln


#endif // ! OLENA_CORE_IMAGE_HH
